import os

SECRET_KEY = "<VEIL_APP_SECRET_KEY>"

ALLOWED_HOSTS = ["127.0.0.1", "localhost"]

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": "<PGSQL_DB_NAME>",
        "USER": "<PGSQL_DB_USER>",
        "PASSWORD": "<PGSQL_DB_PASSWORD>",
        "HOST": "127.0.0.1",
        "PORT": "5432",
        "ATOMIC_REQUESTS": True,
        'OPTIONS': {
            'sslmode': 'disable',
        }
    }
}

ISOLATION_LEVEL = 1

LOGS_DIR = "/var/log/veil/controller"
REDIS_PASSWORD = "<REDIS_DB_PASSWORD>"
REDIS_HOST = "localhost"
REDIS_PORT = 6379
REDIS_DB = 0
if REDIS_PASSWORD is not None:
    REDIS_URL = "redis://:%s@%s:%s/%s" % (REDIS_PASSWORD, REDIS_HOST, REDIS_PORT, REDIS_DB)
else:
    REDIS_URL = "redis://%s:%s/%s" % (REDIS_HOST, REDIS_PORT, REDIS_DB)
REDIS_TIMEOUT = 5

CONTROLLER_USER = "<CONTROLLER_SYS_USER>"

# websockify settings
WS_TOKEN_EXPTIME = 30
WS_PORT = "6080"

# controller settings
CTRL_LOCAL_DATA_PATH = '<CONTROLLER_DIR>/local_data/'

# worker user settings
WORKER_USER = 'veil-node'
WORKER_USER_SSH_DIR = "/var/lib/ecp-veil/.users/%s/.ssh/" % WORKER_USER
WORKER_USER_SSH_PRIVATE = os.path.join(WORKER_USER_SSH_DIR, "id_rsa")
WORKER_USER_SSH_PUBLIC = os.path.join(WORKER_USER_SSH_DIR, "id_rsa.pub")

# networkinf settings
SYS_CLASS_NET_PARSER = True

# sync proxy
SYNC_WAIT_TIMEOUT = 60
FORBIDDEN_SYNC_HEADER = "FORBIDDEN_SYNC"
